# История изменений
Все значимые изменения данного проекта документируются в этом файле.   
*Примечание*: ранние версие могут не соответствовать общепринятой системе семантического версионирования.

История изменений на других языках:  
[английский](CHANGELOG.md)

## [3.2.7] - 2020-11-02
### Изменено
- Исправлено поведение `backgroundClickCallback`. В предыдущей версии он искал `.easy-popup`, где есть `:hover`. Теперь он проверяет, что элемент `.easy-popup-tint` является текущим, и только потом выполняет переданный коллбек.

## [3.2.6] - 2020-08-26
### Изменено
- Исправлен баг в методе `setLoading`. В предыдущих версиях индикатор (картинка) загрузки применялся ко всем экземплярам ***EasyPopup***, вместо текущего.

## [3.2.5] - 2020-06-22
### Изменено
- Добавлен новый CSS-класс ***easy-popup_body-open*** в замену ***easy-popup_overflow*** и ***easy-popup_ios*** для индикации - открыт попап или нет. Предыдущая версия попапа - неверная, т.к. контент внутри ***body*** на устройствах iOS удалялся даже при закрытом попапе. Версию 3.2.4 не следует использовать на устройствах iOS.

## [3.2.4 - некорректная версия] - 2020-06-22
### Изменено
- Исправлен баг параметра ***hideOnIos*** (использовался неверный CSS-класс: ***easy-popup_overflow*** вместо ***easy-popup_ios***).

## [3.2.3] - 2020-06-17
### Изменено
- Исправлена работа проверки ReCaptcha на устройствах с iOS (было невозможно пройти проверку ReCatpcha, если капча была размещена внутри попапа).

## [3.2.2] - 2020-01-27
### Изменено
- Исправлена ошибка с незаданной переменной ***popupCloser***.

## [3.2.1] - 2019-09-04
### Изменено
- Исправлена ошибка ***localFunctions*** в модульной версии.

## [3.2.0] - 2019-09-03
### Добавлено
- В конструктор попапа добавлен параметр ***hideOnIos***. Он скрывает указанные элементы DOM (см. список параметров, которые принимает конструктор попапа).

### Изменено
- Класс `easy-popup_overflow` теперь также добавляется к элементам ***body*** и ***html*** на устройствах IOs. Эти элементы также получают класс `easy-popup_ios`, если параметр ***hideOnIos*** задан и является действительным.

## [3.1.1] - 2019-09-02
### Изменено
- Исправлена ошибка скорости попапа в модульной версии.

## [3.1.0] - 2019-09-02
### Добавлено
- В методы ***show*** и ***close*** добавлены параметры скорости открытия и закрытия (см. параметры ***speed*** и ***closingSpeed*** в методе ***show***, и параметр ***speed*** в методе ***close***).

## [3.0.7] - 2019-08-30
### Изменено
- Исправлен баг с параметром ***minLoadingTime***. Теперь он может быть равен ***0*** без дополнительного таймаута.
- Метод ***unsetLoading*** больше не возвращает *false*, а вместо этого возвращает объект попапа.
- Babel Polyfill перемещён из optionalDependencies в devDependencies.

## [3.0.6] - 2019-07-17
### Изменено
- В стилях убран атрибут ***data-id*** у элемента `.easy-popup-tint`.

## [3.0.5] - 2019-07-06
### Добавлено
- Добавлен CHANGELOG.md. Все описания изменений по версиям перенесены из README.md в CHANGELOG.md.

## [3.0.4] - 2019-07-06
### Добавлено
- Добавлена информация по установке через Composer, пакет также обновлён для использования в качестве npm-asset в Composer.

## [3.0.3] - 2019-07-06
### Добавлено
- Добавлена версия *README* на английском.

## [3.0.2] - 2019-07-02
### Изменено
- Исправлен мелкий баг соответствия стилей в скрипте и файлах стилей.

## [3.0.1] - 2019-06-28
### Изменено
- Исправлен баг стилей для ois при прокрутке попапа. (Ранее при прокрутке за инпут попап не прокручивался.) 

## [3.0.0] - 2019-06-25
### Добавлено
- Добавлена поддержка подключения скрипта в качестве модуля (подробности подключения см. выше).
- Изменён принцип анимации. Теперь используется анимация на базе css (***@keyframes***). Скрипт содержит анимацию по умолчанию, но также принимает пользовательские анимации. Анимация по умолчанию может быть изменена через конструктор, но также возможно передавать анимации для отдельных операций открытия/закрытия в методы ***show*** и ***close***. Подробности вызова см. выше.
- Элементу `.easy-popup-tint` (ранее `.simple-popup-tint`) теперь присваивается атрибут ***data-id***, содержащий уникальный идентификатор объекта попапа. Данный атрибут присваивается каждый раз при создании нового экземпляра попапа (за исключением случаев, когда в целевом родительском элементе (***appendTo***) уже существует элемент `.easy-popup-tint` с атрибутом ***data-id***). В конструктор добавлен параметр ***id***, позволяющий задать идентификатор вручную. Если данный параметр не передан, по умолчанию генерируется случайный идентификатор.

### Изменено 
- Пакет переименован из ***simple-popup*** в ***easy-popup***, т.к. на момент публикации имя ***simple-popup*** уже занято в ***npm***. Соответственно, изменено имя объекта попапа c ***SimplePopup*** на ***EasyPopup***, а также изменены приставки в css-классах с ***simple-popup*** на ***easy-popup***.
- ***jQuery*** исключён из списка зависимостей. В скрипте теперь используется только нативный js.
- Исправлены коллбеки, выполняющиеся при событиях.
- Переименованы три метода конструктора в соответствии со своим смысловым назначением:   
    `closeOnBackgroundClick` -> `allowBackgroundCallback`   
    `closeOnEsc` -> `allowCallbackOnEsc`   
    `confirmOnEnter` -> `allowCallbackOnEnter`   
- Картинка загрузки по умолчанию (***loadingPic***) заменена на более компактную в целях оптимизации. Если требуется подключить предыдущую, можно сделать это через параметры. Старая картинка находится в папке *img* (`loading.gif`).

## [2.2.0] - 2019-06-19
### Добавлено
- В конструктор добавлен параметр ***appendTo***, обозначающий селектор, в который будет вставлен html-код скрипта.
- В конструктор добавлен параметр ***noScrollTop***, запрещающий автопрокрутку (скроллинг) попапов.

## [2.1.0] - 2019-05-20
### Добавлено
- В методе ***show*** теперь можно передавать параметр ***name*** со значением *false*, в таком случае не будет активного окна попапа (полезно, например, при использовании метода ***setLoading***).

## [2.0.1] - 2019-03-28
### Изменено
- Класс ***simple-popup_overflow*** не проставляется для устройств с ios

## [2.0.0] - 2019-02-19
### Добавлено
- Добавлены методы ***setLoading*** и ***unsetLoading***, отвечающие за отображение/скрытие полноэкранного индикатора загрузки (подробное описание см. выше в списке методов).
- В конструктор попапа добавлен параметр ***minLoadingTime***, обозначающий минимальное время, в течение которого должна отображаться анимация загрузки, а также параметр ***loadingPic*** - URL картинки, которая будет использоваться в качестве индикатора загрузки.

### Изменено
- Изменены основные CSS-классы попапа:   
    `.tint` -> `.simple-popup-tint`   
    `.popup` -> `.simple-popup`   
    `.heading` -> `.simple-popup__heading`   
    `.body` -> `.simple-popup__body`   
    `.text` -> `.simple-popup__text`   
    `.closer` -> `.simple-popup__closer`   
    `.h_overflow` -> `.simple-popup_overflow`   
- Объект попапа переименован из ***Popup*** в ***SimplePopup***.
- Все методы объекта ***SimplePopup*** теперь возвращают сам этот объект.

### Удалено 
- Свойство ***scrollTop*** удалено из конструктора, т.к. оно должно меняться только специальными обработчиками.

## [1.3.4] - 2019-02-08
### Добавлено
- Класс ***h_overflow***, используемый при динамическом создании css-стилей через js, также внесён в css-файлы.
- К объекту ***Popup*** добавлено свойство ***isActive***, равное *true*, если какой-либо попап открыт, и равное *false* - если нет.

### Изменено
- Последнее положение скролла запоминается только если попап закрыт, а если открыт - используется сохранённое значение.

## [1.3.3] - 2019-01-14
### Изменено
- Исправлен баг со скроллом после открытия попапа.

## [1.3.2] - 2018-09-28
### Изменено
- Изменён параметр по умолчанию для ***closingBtnText*** (в попапе `confirm` теперь равен **'Отклонить'**, в попапе `message` равен **'OK'**, в остальных случаях равен ***false***). Параметр по умолчанию срабатывает только для двух указанных попапов, в том числе - если передано ***false*** (по строгому сравнению).
- Изменён параметр по умолчанию для ***confirmBtnText*** (в попапе `confirm` теперь равен **'Подтвердить'**). Параметр по умолчанию срабатывает только для указанного попапа, в том числе - если передано ***false*** (по строгому сравнению).

## [1.3.1] - 2018-08-16
### Изменено
- Исправлено обращение к элементу .tint на body>.tint
- Объект Popup перенесён в область видимости window

## [1.3.0] - 2018-07-18
### Добавлено
- добавлена папка с дефолтными CSS-стилями (подключать не обязательно)
- добавлен файл .json для composer

### Изменено
- Поправлены мелкие баги со стилями
- styles и mediaStyles теперь по умолчанию равны false

### Удалено
- Убрана автоматическая инициализация

## [более ранние версии] - без описания изменений