easy-popup v.3.2.7
=============================

Название в предыдущих версиях: *simple-popup*.   
Простейший скрипт для работы с попапами. Также работает с CSS-стилями и HTML-шаблонами.

Читать на других языках:  
[английский](README.md)

-----------
ЗАВИСИМОСТИ
-----------
Отсутствуют.

---------------------------------------
ПОДКЛЮЧЕНИЕ В КАЧЕСТВЕ ПРОСТОГО СКРИПТА
---------------------------------------
Подключается обычным способом через html:

```html
<script src='src/easy-popup.js'></script>
```

*или*

```html
<script src='src/easy-popup.min.js'></script>
```

--------------------------------
ПОДКЛЮЧЕНИЕ В КАЧЕСТВЕ JS-МОДУЛЯ
--------------------------------

Чтобы подключить в качестве js-модуля, необходимо перейти в директорию проекта 

`cd my/project/path`

и выполнить команду

`npm i --save easy-popup`

а затем в файле приложения выполнить импорт:

```html
import {EasyPopup} from 'easy-popup';
```

------------------------
УСТАНОВКА ЧЕРЕЗ COMPOSER
------------------------

В настоящее время пакета нет в Composer. Тем не менее, его можно подключить как пакет npm (npm asset). Для установки пакета этим способом может быть использован Composer Packagist. Чтобы использовать Packagist, добавьте следующую запись в ваш файл ***composer.json***:

```html
"repositories":[
    {
        "type": "composer",
        "url": "https://asset-packagist.org"
    }
],
```

После этого остаётся только подключить пакет (require), как указано ниже (укажите нужную версию в случае необходимости):

```html
"require": {
    "npm-asset/easy-popup": "^3.0.3" 
},
```

Если не устанавливается нужная версия, необходимо обновить информацию об npm-пакете [в Пакаджисте](https://asset-packagist.org/package/npm-asset/easy-popup).

Для установки по своему пути см. [следующие указания](https://asset-packagist.org/site/about).

-------------
ИНИЦИАЛИЗАЦИЯ
-------------

Для инициализации необходимо создать экземпляр объекта ***EasyPopup*** с требуемыми параметрами с помощью ***new***: 

```html
var myPopup = new EasyPopup(params);
```

где ***params*** - объект с параметрами.

------------------
ПОДКЛЮЧЕНИЕ СТИЛЕЙ
------------------

Возможно подключение стилей обычным способом и при инициализации скрипта.   

Обычный способ: 

```html
<link rel="stylesheet" href='src/css/easy-popup.css'>
```

или

```html
<link rel="stylesheet" href='src/css/easy-popup.min.css'>
```

Альтернативный вариант - включить встроенные стили при инициализации скрипта, для этого необходимо в конструктор попапа передать два параметра:

```html
var myPopup = new EasyPopup({
    styles: true,
    mediaStyles: true
});
```

Чтобы работали стили, эти два параметра не должны принимать значение ***false***. Следовательно, не обязательно передавать ***true***, а можно передать объект со своими пользовательскими стилями.   

Также возможно полностью отказаться от подключения предложенных стилей и написать все стили полностью самостоятельно.

--------------------------------------------------------
СПИСОК ПАРАМЕТРОВ, КОТОРЫЕ ПРИНИМАЕТ КОНСТРУКТОР ПОПАПА:
--------------------------------------------------------
***Параметры принимаются в виде объекта с указанными ниже свойствами:***

  ***styleSheetTitle*** `string`
  
> ***title*** новой таблицы стилей (***title*** тега `style`) в DOM (используется только для проверки инициализации скрипта, далее всё пишется в уже существующую таблицу стилей). Для работы с попапами данный параметр не требуется.

  ***speed*** `number`
    
> Скорость попапа. По умолчанию установлено значение ***150***.

  ***allowBackgroundCallback*** `boolean`
  
> Разрешить ли выполнение коллбека при клике на фон (`.easy-popup-tint`). Если коллбек разрешен, то по умолчанию клик по фону закрывает попап. Также в методе ***show*** на клик по фону можно повесить свой коллбек (***backgroundClickCallback***).

  ***allowCallbackOnEsc*** `boolean`
  
> Разрешить ли выполнение коллбека при нажатии ***Esc***. Если коллбек разрешен, то по умолчанию нажатие ***Esc*** закрывает попап. Также в методе ***show*** на клавишу ***Esc*** можно повесить свой коллбек (***callbackOnEsc***).

  ***allowCallbackOnEnter*** `boolean`
  
> Разрешить ли выполнение коллбека при нажатии ***Enter***. Если коллбек разрешен, то по умолчанию нажатие ***Enter*** запускает коллбек подтверждения ***confirmBtnCallback***, при этом по умолчанию он равен пустой функции `function(){}`. Если ***confirmBtnCallback*** принимает значение *false*, - запускается коллбек закрытия (***closerCallback***). Также в методе ***show*** на клавишу ***Enter*** можно повесить свой отдельный коллбек (***callbackOnEnter***).

  ***templates*** `object`
      
> Объект с дополнительными шаблонами попапов, которые нужно добавить к уже имеющимся, а также с элементами, которые нужно удалить из имеющихся (например, если передано свойство ***confirm*** со значением *false*, внутри блока `.easy-popup-tint` производится поиск всех элементов `.easy-popup[data-name="confirm"]`, и все найденные элементы удаляются).


  ***styles*** `object`
    
> Объект с кастомизированными стилями для попапов, которые перезапишут/дополнят дефолтные стили (если передано значение *false*, то стили из js-скрипта не применяются, включая медиазапросы, по умолчанию установлено в *false*, т.е. дефолтные стили, заданные в скрипте, не применяются). Вместо работы со стилями через js возможно подключить css-файл (см. папку *css*).

  ***mediaStyles*** `object`
    
> Объект с кастомизированными медиазапросами (структура аналогична объекту ***styles***, только тут каждый такой объект дополнительно оборачивается в строку медиазапроса), для обработки медиазапросов ***styles*** не должен быть равен *false*. Если ***mediaStyles*** равен *false*, медиазапросы из js-скрипта не применяются. По умолчанию принимает значение *false*.

  ***replaceStyles*** `boolean`
    
> По умолчанию свойства объекта каждого селектора в переданных параметрах дополняют свойства соответствующего объекта в стилях по умолчанию, т.е. учитываются и те, которые заданы по умолчанию, и переданные в параметрах. Если ***replaceStyles*** установлен в *true*, то объект стилей по умолчанию (для каждого селектора) полностью перезаписывается на тот, который был передан в параметрах, даже если там всего одно свойство, или вообще их нет.

  ***minLoadingTime*** `number`
    
> Минимальное время, в течение которого должна отображаться анимация (или картинка) загрузки при использовании метода ***setLoading***.

  ***loadingPic*** `string`
    
> URL анимации или картинки, которая должна отображаться в качестве индикатора загрузки при использовании метода ***setLoading***. Поддерживается передача строки в виде *base64*. По умолчанию отображаются маленькие песочные часы в целях компактности. Если требуется полноценная анимированная картинка, можно поставить свою, либо подключить картинку `loading.gif` из папки *src/img*.

  ***appendTo*** `string | false`
    
> Селектор, в который будет вставлен html-код скрипта. Формат написания селектора стандартный, как в css. Если передано *false*, то html-код скрипта будет вставлен в селектор по умолчанию.

  ***noScrollTop*** `boolean`
    
> Запретить автопрокрутку (скроллинг) попапов с помощью метода ***scrollTop***. Также данный параметр (если равен *true*) отключает присвоение элементам css-класса ***easy-popup_overflow***.

  ***defaultAnimationShow*** `string`
    
> Название css-анимации (заданной с помощью @keyframes), используемой по умолчанию при открытии попапа. Если данный параметр не передан, по умолчанию используется встроенная анимация ***easyPopupShow***.

  ***defaultAnimationClose*** `string`
    
> Название css-анимации (заданной с помощью @keyframes), используемой по умолчанию при закрытии попапа. Если данный параметр не передан, по умолчанию используется встроенная анимация ***easyPopupClose***.

  ***id*** `string`
    
> Уникальный идентификатор объекта попапа, присваиваемый элементу `.easy-popup-tint` с помощью дата-атрибута ***data-id***. По умолчанию в качестве идентификатора генерируется и присваевается случайная строка (от даты и рандомного числа). Данный атрибует присваивается каждый раз при создании нового экземпляра попапа (за исключением случаев, когда в целевом родительском элементе (***appendTo***) уже существует элемент `.easy-popup-tint` с атрибутом ***data-id***). В случае когда в целевом родительском элементе уже существует элемент `.easy-popup-tint` с атрибутом ***data-id***, значение этого ***data-id*** присваевается объекту попапа в качестве ***id*** (т.е. свойство объекта попапа перезаписывается из дата-атрибута).

  ***hideOnIos*** `false | string | object`
    
> Этот параметр принимает селектор(ы) в виде строки или массива строк, а затем скрывает все элементы DOM, соответствующие переданным селекторам. Данное правило действует только на устройствах IOs для потомков элемента `easy-popup_overflow`, если он существует. В противном случае параметр не отрабатывает. Это может быть полезно в связи с известными проблемами скролла в фиксированных элементах в *Safari*, в таком случае можно совсем скрыть все элементы внутри ***body*** на период отображения попапа.

----------------
ОСНОВНЫЕ МЕТОДЫ:
----------------

### show (показать попап):

***Так же как и в конструкторе попапа, параметры принимаются в виде объекта. Свойства объекта описаны ниже:***

  ***title*** `string`
  
> Заголовок попапа.

  ***text*** `string`
  
> Текст попапа.

  ***btnEvents*** `boolean`
  
> Включить/отключить события при клике на кнопки `.closing_button` и `.confirm_button`.

  ***name*** `string`
  
> Имя попапа, который вызывается (атрибут ***data-name***). По умолчанию - ***message***.

  ***html*** `string`
  
> Применить HTML-шаблон, если он передан (при этом игнорируются параметры ***title***, ***text*** и ***name***).

  ***closerCallback*** `function | object`
  
> Callback, который вызывается при нажатии на `.closer`. Если является объектом, то принимается два свойства: `closerOff` (если нужно отключить закрытие попапа - установить в `true`) и `callback` (непосредственно передаваемый callback, который будет вызываться при закрытии)

  ***closingBtnCallback*** `function`
  
> Если на `.closing_button` нужно повесить отдельный callback - передать сюда (если передан - заменит дефолтный).

  ***confirmBtnCallback*** `function`
  
> Если на `.confirm_button` нужно повесить отдельный callback - передать сюда (если передан - заменит дефолтный).

  ***backgroundClickCallback*** `function`
  
> Если при клике на `.tint` (фон) нужен отдельный callback - передать сюда.

  ***callbackOnEsc*** `function`
  
> Если при нажатии ***Esc*** нужен отдельный callback - передать сюда.

  ***callbackOnEnter*** `function`
  
> Если при нажатии ***Enter*** нужен отдельный callback - передать сюда.

  ***closingBtnText*** `string`
  
> Задать свой текст для кнопки закрытия `.closing_button` (принимает HTML).

  ***confirmBtnText*** `string`
  
> Задать свой текст для кнопки подтверждения `.confirm_button` (принимает HTML).

  ***animationShow*** `string`
  
> Название css-анимации (заданной с помощью @keyframes), используемой для открытия данного конкретного попапа, т.е. однократно. Если данный параметр не передан, используется анимация для открытия попапа по умолчанию.

  ***animationClose*** `string`
  
> Название css-анимации (заданной с помощью @keyframes), используемой для анимации закрытия ранее открытого попапа, т.е. однократно. Пояснение: если текущий попап вызывается при ранее открытых, но ещё не закрытых попапах, то происходит замена старого попапа на текущий, при этом старый будет закрываться с анимацией, переданной в данный параметр. Если данный параметр не передан, используется анимация для закрытия попапа по умолчанию.

***speed*** `number`
  
> Скорость открытия попапа. По умолчанию равна *false*. В случае если она равна *false*, вместо неё используется скорость из объекта попапа.

***closingSpeed*** `number`
  
> Скорость закрытия ранее открытого попапа. По умолчанию равна *false*. В случае если она равна *false*, вместо неё используется скорость из объекта попапа.

-----------------------------------
### close (закрыть попап):

***Параметры принимаются в виде объекта. Свойства объекта описаны ниже:***

***callback*** `function`
  
> Callback, который выполнится перед закрытием попапа.

***stopAfterCallback*** `boolean`
  
> Если имеет значение *true*, скрипт прерывается после вызова коллбека. Если не передан - по умолчанию после вызова коллбека попап закрывается.

***animationClose*** `string`
  
> Название css-анимации (заданной с помощью @keyframes), используемой для закрытия данного конкретного попапа, т.е. однократно. Если данный параметр не передан, используется анимация для закрытия попапа по умолчанию.

***speed*** `number`
  
> Скорость закрытия попапа. По умолчанию равна *false*. В случае если она равна *false*, вместо неё используется скорость из объекта попапа.

-----------------------------------
### setLoading (показать полноэкранный индикатор загрузки поверх всего остального контента):

***Принимается два параметра:***

  `number`
  
> Минимальное время, в течение которого должна отображаться анимация (или картинка) загрузки.

  `string`
  
> URL анимации или картинки, которая должна отображаться в качестве индикатора загрузки. Поддерживается передача строки в виде *base64*.

-----------------------------------
### unsetLoading (скрывает индикатор загрузки, вызванный методом setLoading):

***Используется без передачи параметров***

-------------
ПРИМЕР ВЫЗОВА
-------------
См. пример использования попапа в папке ***test***.

----------------------------
ИСТОРИЯ ИЗМЕНЕНИЙ ПО ВЕРСИЯМ
----------------------------
Все описания изменений можно найти в [CHANGELOG.ru.md](CHANGELOG.ru.md).